package fr.ill.ics.n3d.io;

import java.util.HashMap;

/**
 * @author dages
 *
 */
public class AsciiStringConverter {

	private static final HashMap<Character, String> conversion = new HashMap<>();
	static {
		conversion.put(' ', "_");
		conversion.put('', "a");
		conversion.put('', "a");
		conversion.put('', "e");
		conversion.put('', "e");
		conversion.put('', "e");
		conversion.put('', "e");
		conversion.put('', "i");
		conversion.put('', "i");
		conversion.put('', "i");
		conversion.put('', "o");
		conversion.put('', "o");
		conversion.put('', "o");
		conversion.put('', "u");
		conversion.put('', "u");
		conversion.put('', "u");
		conversion.put('', "n");
		conversion.put('', "c");
		conversion.put('', "A");
		conversion.put('', "A");
		conversion.put('', "E");
		conversion.put('', "E");
		conversion.put('', "E");
		conversion.put('', "E");
		conversion.put('', "I");
		conversion.put('', "I");
		conversion.put('', "I");
		conversion.put('', "O");
		conversion.put('', "O");
		conversion.put('', "O");
		conversion.put('', "O");
		conversion.put('', "U");
		conversion.put('', "U");
		conversion.put('', "U");
		conversion.put('', "U");
		conversion.put('', "N");
		conversion.put('', "C");
		conversion.put('<', "leftchevron");
		conversion.put('>', "rightchevron");
		conversion.put('\"', "doublequote");
		conversion.put('\'', "quote");
		conversion.put('&', "ampersand");
		conversion.put('@', "at");
		conversion.put('#', "sharp");
		conversion.put('~', "tilde");
		conversion.put('`', "backquote");
		conversion.put('\\', "backslash");
		conversion.put('^', "circumflex");
		conversion.put('', "umlaut");
		conversion.put('$', "dollar");
		conversion.put('', "euro");
		conversion.put('', "pound");
		conversion.put('', "currency");
		conversion.put('', "mu");
		conversion.put('', "squared");
		conversion.put('', "paragraph");
		conversion.put('%', "percent");
		conversion.put('=', "equals");
		conversion.put('', "degree");
		conversion.put('(', "leftparenthesis");
		conversion.put(')', "rightperenthesis");
		conversion.put('[', "leftsquarebracket");
		conversion.put(']', "rightsquarebracket");
		conversion.put('{', "leftcurlybracket");
		conversion.put('}', "rightcurlybracket");
	}
	
	/**
	 * Default constructor.
	 */
	public AsciiStringConverter() {
	}

	public String convert(String value) {
		String result = new String(value);
		for (Character c : conversion.keySet()) {
			result = result.replace(c.toString(), conversion.get(c));
		}
		return result;
	}

}
