/**
 * 
 */
package fr.ill.ics.n3d.model;

import java.util.logging.Logger;

import javafx.geometry.Point3D;
import javafx.scene.transform.Transform;

/**
 * @author dages
 *
 */
public class AngleMate extends Mate {
	
	public static final String XML_TYPE_NAME = "Angle";

	/**
	 * Default cosntructor.
	 */
	public AngleMate() {
		super();
	}

	@Override
	public void apply(Axis translation, Axis rotation, Transform rootToScene) {
		// Each mates reduce the number of DOFs
		Point3D rootOrigin = rootToScene.transform(Point3D.ZERO);
		Point3D[] matePositions = {rootToScene.transform(this.getEntity(0).getPosition()), rootToScene.transform(this.getEntity(1).getPosition())};
		Point3D[] mateAxes = {
				rootToScene.transform(this.getEntity(0).getAxis()).subtract(rootOrigin).normalize(), 
				rootToScene.transform(this.getEntity(1).getAxis()).subtract(rootOrigin).normalize()
			};

		Logger.getLogger("nomad-3d").warning("Angle mate entities " + this.getEntity(0).getType() + " - " + this.getEntity(1).getType() + " not handled");
	}
	
	@Override
	public String toString() {
		return XML_TYPE_NAME + super.toString();
	}

}
